
-- VHDL Test Bench Created from source file rx.vhd -- 12:34:00 11/03/2004
--
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY rx_tb IS
END rx_tb;

ARCHITECTURE behavior OF rx_tb IS 

--specman
component comspec
end component;
for all: comspec use entity work.SPECMAN_REFERENCE (arch);

        CONSTANT clk_period         : time      := 20 ns;
        CONSTANT ck_period_mult     : integer   := 3;

        CONSTANT ck_en_period       : time      := clk_period * ck_period_mult;

	COMPONENT rx
	PORT(
		rx_in : IN std_logic;
		clk : IN std_logic;
		ck_en : IN std_logic;
		reset : IN std_logic;
		full_clr : IN std_logic;          
		d_out : OUT std_logic_vector(7 downto 0);
		full : OUT std_logic
		);
	END COMPONENT;

	SIGNAL rx_in :  std_logic;
	SIGNAL clk :  std_logic;
	SIGNAL ck_en :  std_logic;
	SIGNAL reset :  std_logic;
	SIGNAL d_out :  std_logic_vector(7 downto 0);
	SIGNAL full :  std_logic;
	SIGNAL full_clr :  std_logic;


BEGIN

	uut: rx PORT MAP(
		rx_in => rx_in,
		clk => clk,
		ck_en => ck_en,
		reset => reset,
		d_out => d_out,
		full => full,
		full_clr => full_clr
	);



   clk_p : PROCESS
	BEGIN
	    CLOCK_LOOP : LOOP
		clk <=  '0';
		WAIT FOR clk_period/2;
		clk <= '1';
		WAIT FOR clk_period/2;
            END LOOP CLOCK_LOOP;
	END PROCESS;

   ck_en_p : PROCESS
	BEGIN
            ck_en <= '0';
            WAIT FOR clk_period/4;
	    CK_EN_LOOP : LOOP
		ck_en <=  '1';
		WAIT FOR clk_period;
		ck_en <= '0';
		WAIT FOR (ck_en_period - clk_period);
            END LOOP CK_EN_LOOP;
	END PROCESS;

   reset_p : PROCESS
	BEGIN
            reset <= '1';
            WAIT FOR 45 ns;
            reset <='0';
            WAIT;
	END PROCESS;


END;
