/*------------------------------------------------------------------------- 
File name   : uart_rx_agent.e
Title       : uart eVC cell structure
Project     : uart eVC
Developers  : Pinhas Krengel http://bknpk.no-ip.biz/my_web/index.html
Created     : Dec 2011
Description : This file declares the agent of the UART RX.
Notes       : 
--------------------------------------------------------------------------- 
==== This source file may be used and distributed without ====
==== restriction provided that this copyright statement is not ====
==== removed from the file and that any derivative work contains ====
==== the original copyright notice and the associated disclaimer.====
==== ====
==== THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY ====
==== EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED ====
==== TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS ====
==== FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE AUTHOR ====
==== OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, ====
==== INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES ====
==== (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE ====
==== GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR ====
==== BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF ====
==== LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ====
==== (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT ====
==== OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE ====
==== POSSIBILITY OF SUCH DAMAGE. ====
-------------------------------------------------------------------------*/ 
<'
package pk_rx;

unit uart_rx_agent_u {
  name : uart_rx_env_name_t;

  active_passive : erm_active_passive_t;
  keep soft active_passive == ACTIVE;

  sig : sig_map_u is instance;

  mon : uart_rx_monitor_u is instance;
  keep mon.name == read_only(name);
  keep mon.sig  == sig;

};--uart_rx_agent_u

extend ACTIVE uart_rx_agent_u {
  rx_driver : uart_rx_driver_u is instance;
  keep rx_driver.name == read_only(name);

  bfm : uart_rx_bfm_u is instance;
  keep bfm.name == read_only(name);
  keep bfm.sig  == sig;
  keep bfm.rx_driver == rx_driver;

};--extend ACTIVE uart_rx_agent_u

'>


