
-- VHDL Test Bench Created from source file tx.vhd -- 11:02:26 11/04/2004
--

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

--Pini support tx data other than 0x55
use IEEE.STD_LOGIC_UNSIGNED."+";

ENTITY tx_tb IS
END tx_tb;

ARCHITECTURE behavior OF tx_tb IS 

--specman
component comspec
end component;
for all: comspec use entity work.SPECMAN_REFERENCE (arch);



CONSTANT clk_period         : time      := 20 ns;
CONSTANT ck_period_mult     : integer   := 5;

CONSTANT ck_en_period       : time      := clk_period * ck_period_mult;

COMPONENT tx
  PORT(
    d_in : IN std_logic_vector(7 downto 0);
    load : IN std_logic;
    clk : IN std_logic;
    ck_en : IN std_logic;
    reset : IN std_logic;          
    tx_out : OUT std_logic;
    busy : OUT std_logic
  );
END COMPONENT;

SIGNAL tx_out :  std_logic;
SIGNAL d_in :  std_logic_vector(7 downto 0);
SIGNAL busy :  std_logic;
SIGNAL load :  std_logic;
SIGNAL clk :  std_logic;
SIGNAL ck_en :  std_logic;
SIGNAL reset :  std_logic;
--Pini support tx data other than 0x55
SIGNAL dinp :  std_logic_vector(7 downto 0) := "01010101";

BEGIN

uut: tx PORT MAP(
  tx_out => tx_out,
  d_in => d_in,
  busy => busy,
  load => load,
  clk => clk,
  ck_en => ck_en,
  reset => reset
);

clk_p : PROCESS begin
  CLOCK_LOOP : LOOP
    clk <=  '0';
    WAIT FOR clk_period/2;
    clk <= '1';
    WAIT FOR clk_period/2;
  END LOOP CLOCK_LOOP;
END PROCESS;

ck_en_p : PROCESS begin
  ck_en <= '0';
  WAIT FOR clk_period/4;
  CK_EN_LOOP : LOOP
    ck_en <=  '1';
    WAIT FOR clk_period;
    ck_en <= '0';
    WAIT FOR (ck_en_period - clk_period);
  END LOOP CK_EN_LOOP;
END PROCESS;

reset_p : PROCESS begin
  reset <= '1';
  WAIT FOR 45 ns;
  reset <='0';
  WAIT;
END PROCESS;


END;


