/*------------------------------------------------------------------------- 
File name   : uart_sequence_tx.e
Title       : uart eVC cell structure
Project     : uart eVC
Developers  : Pinhas Krengel http://bknpk.no-ip.biz/my_web/index.html
Created     : Dec 2011
Description : This file implements TX sequences.
Notes       : 
--------------------------------------------------------------------------- 
==== This source file may be used and distributed without ====
==== restriction provided that this copyright statement is not ====
==== removed from the file and that any derivative work contains ====
==== the original copyright notice and the associated disclaimer.====
==== ====
==== THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY ====
==== EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED ====
==== TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS ====
==== FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE AUTHOR ====
==== OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, ====
==== INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES ====
==== (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE ====
==== GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR ====
==== BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF ====
==== LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ====
==== (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT ====
==== OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE ====
==== POSSIBILITY OF SUCH DAMAGE. ====
-------------------------------------------------------------------------*/ 
<'
package pk_tx;

--logical name
type uart_tx_env_name_t : [];
sequence uart_tx_sequence using item=uart_tx_byte_s, 
created_driver=uart_tx_driver_u;

extend uart_tx_byte_s {
  name : uart_tx_env_name_t;
  keep name == read_only(driver).name;

};--extend uart_tx_byte_s

extend uart_tx_sequence {
  name : uart_tx_env_name_t;
  keep name == read_only(driver).name;

  tx_byte : uart_tx_byte_s;
};--extend uart_tx_sequence

extend uart_tx_driver_u {
  name : uart_tx_env_name_t;
};--extend uart_tx_driver_u

extend MAIN uart_tx_sequence {

  drain_time : time;
  keep soft drain_time == 20 us;

  pre_body() @sys.any is first {
    message(NONE, "dbg raise_objection");
    driver.raise_objection(TEST_DONE);
  }; -- pre_body()
         
  post_body() @sys.any is also {
    messagef(NONE, "dbg A drop_objection %d", drain_time);
    wait delay(drain_time);
    message(NONE, "dbg B drop_objection");
    driver.drop_objection(TEST_DONE);
  }; -- post_body()
    
}; -- extend MAIN uart_tx_sequence

'>

